'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _nativeProcedure = require('../value/nativeProcedure');

var _nativeProcedure2 = _interopRequireDefault(_nativeProcedure);

var _character = require('../value/character');

var _character2 = _interopRequireDefault(_character);

var _number = require('../value/number');

var _number2 = _interopRequireDefault(_number);

var _boolean = require('../value/boolean');

var _boolean2 = _interopRequireDefault(_boolean);

var _value = require('../value');

var _createComparator = require('./util/createComparator');

var _createComparator2 = _interopRequireDefault(_createComparator);

var _assert = require('../util/assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = [new _nativeProcedure2.default('char?', function (list) {
  return new _boolean2.default(list.car && list.car.type === _value.CHARACTER);
}),
// code point supports UTF-16 surrogate chars, however some browsers may
// not support it.
new _nativeProcedure2.default('char->integer', function (list) {
  (0, _assert2.default)(list.car, 'character');
  return new _number2.default(list.car.value.codePointAt(0));
}), new _nativeProcedure2.default('integer->char', function (list) {
  (0, _assert2.default)(list.car, 'number');
  return new _character2.default(String.fromCodePoint(list.car.value));
}), (0, _createComparator2.default)('char=?', _value.CHARACTER, function (a, b) {
  return a === b;
}), (0, _createComparator2.default)('char<?', _value.CHARACTER, function (a, b) {
  return a < b;
}), (0, _createComparator2.default)('char>?', _value.CHARACTER, function (a, b) {
  return a > b;
}), (0, _createComparator2.default)('char<=?', _value.CHARACTER, function (a, b) {
  return a <= b;
}), (0, _createComparator2.default)('char>=?', _value.CHARACTER, function (a, b) {
  return a >= b;
})];