'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _nativeProcedure = require('../../value/nativeProcedure');

var _nativeProcedure2 = _interopRequireDefault(_nativeProcedure);

var _pair = require('../../value/pair');

var _pair2 = _interopRequireDefault(_pair);

var _value = require('../../value');

var _assert = require('../../util/assert');

var _assert2 = _interopRequireDefault(_assert);

var _list = require('./list.scm');

var _list2 = _interopRequireDefault(_list);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = [new _nativeProcedure2.default('cons*', function (list) {
  var listHead = void 0,
      listTail = void 0;
  var node = list;
  while (node != null && node.cdr != null) {
    var pairValue = new _pair2.default(node.car);
    if (listHead == null) {
      listHead = pairValue;
      listTail = pairValue;
    } else {
      listTail.cdr = pairValue;
      listTail = pairValue;
    }
    node = node.cdr;
  }
  if (listHead == null) {
    return node.car;
  }
  listTail.cdr = node.car;
  return listHead;
}, null, 'args'), new _nativeProcedure2.default('list-sort', function (list, machine) {
  (0, _assert2.default)(list.car, _value.PROCEDURE);
  (0, _assert2.default)(list.cdr.car, _value.PAIR);
  // Just borrow native implementation
  var array = list.cdr.car.toArray();
  array.sort(function (a, b) {
    machine.pushStack(new _pair2.default(list.car, new _pair2.default(a, new _pair2.default(b))));
    var result = machine.execute();
    return result.type != _value.BOOLEAN || result.value === true ? -1 : 1;
  });
  return _pair2.default.fromArray(array);
}, ['proc', 'list']), _list2.default];