'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _nativeProcedure = require('../../value/nativeProcedure');

var _nativeProcedure2 = _interopRequireDefault(_nativeProcedure);

var _character = require('../../value/character');

var _character2 = _interopRequireDefault(_character);

var _string = require('../../value/string');

var _string2 = _interopRequireDefault(_string);

var _boolean = require('../../value/boolean');

var _boolean2 = _interopRequireDefault(_boolean);

var _value = require('../../value');

var _assert = require('../../util/assert');

var _assert2 = _interopRequireDefault(_assert);

var _createComparator = require('../util/createComparator');

var _createComparator2 = _interopRequireDefault(_createComparator);

var _unicode = require('./unicode.scm');

var _unicode2 = _interopRequireDefault(_unicode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = [new _nativeProcedure2.default('char-upcase', function (list) {
  (0, _assert2.default)(list.car, 'character');
  return new _character2.default(list.car.value.toUpperCase());
}, ['char']), new _nativeProcedure2.default('char-downcase', function (list) {
  (0, _assert2.default)(list.car, 'character');
  return new _character2.default(list.car.value.toLowerCase());
}, ['char']), (0, _createComparator2.default)('char-ci=?', _value.CHARACTER, function (a, b) {
  return a.toLowerCase() === b.toLowerCase();
}), (0, _createComparator2.default)('char-ci<?', _value.CHARACTER, function (a, b) {
  return a.toLowerCase() < b.toLowerCase();
}), (0, _createComparator2.default)('char-ci>?', _value.CHARACTER, function (a, b) {
  return a.toLowerCase() > b.toLowerCase();
}), (0, _createComparator2.default)('char-ci<=?', _value.CHARACTER, function (a, b) {
  return a.toLowerCase() <= b.toLowerCase();
}), (0, _createComparator2.default)('char-ci>=?', _value.CHARACTER, function (a, b) {
  return a.toLowerCase() >= b.toLowerCase();
}), new _nativeProcedure2.default('char-alphabetic?', function (list) {
  (0, _assert2.default)(list.car, 'character');
  return new _boolean2.default(/^[a-zA-Z]+$/i.test(list.car));
}, ['char']), new _nativeProcedure2.default('char-numeric?', function (list) {
  (0, _assert2.default)(list.car, 'character');
  return new _boolean2.default(/^[0-9]+$/i.test(list.car));
}, ['char']), new _nativeProcedure2.default('char-whitespace?', function (list) {
  (0, _assert2.default)(list.car, 'character');
  return new _boolean2.default(/^\s+$/i.test(list.car));
}, ['char']), new _nativeProcedure2.default('char-upper-case?', function (list) {
  (0, _assert2.default)(list.car, 'character');
  return new _boolean2.default(list.car.toUpperCase() === list.car && list.car.toLowerCase() !== list.car);
}, ['char']), new _nativeProcedure2.default('char-lower-case?', function (list) {
  (0, _assert2.default)(list.car, 'character');
  return new _boolean2.default(list.car.toUpperCase() !== list.car && list.car.toLowerCase() === list.car);
}, ['char']),
// Implementing char-general-category is totally unnecessary.
new _nativeProcedure2.default('string-upcase', function (list) {
  (0, _assert2.default)(list.car, 'string');
  return new _string2.default(list.car.value.toUpperCase());
}, ['string']), new _nativeProcedure2.default('string-downcase', function (list) {
  (0, _assert2.default)(list.car, 'string');
  return new _string2.default(list.car.value.toLowerCase());
}, ['string']), (0, _createComparator2.default)('string-ci=?', _value.STRING, function (a, b) {
  return a.toLowerCase() === b.toLowerCase();
}), (0, _createComparator2.default)('string-ci<?', _value.STRING, function (a, b) {
  return a.toLowerCase() < b.toLowerCase();
}), (0, _createComparator2.default)('string-ci>?', _value.STRING, function (a, b) {
  return a.toLowerCase() > b.toLowerCase();
}), (0, _createComparator2.default)('string-ci<=?', _value.STRING, function (a, b) {
  return a.toLowerCase() <= b.toLowerCase();
}), (0, _createComparator2.default)('string-ci>=?', _value.STRING, function (a, b) {
  return a.toLowerCase() >= b.toLowerCase();
}), new _nativeProcedure2.default('string-normalize-nfd', function (list) {
  (0, _assert2.default)(list.car, 'string');
  return new _string2.default(list.car.value.normalize('NFD'));
}, ['string']), new _nativeProcedure2.default('string-normalize-nfkd', function (list) {
  (0, _assert2.default)(list.car, 'string');
  return new _string2.default(list.car.value.normalize('NFKD'));
}, ['string']), new _nativeProcedure2.default('string-normalize-nfc', function (list) {
  (0, _assert2.default)(list.car, 'string');
  return new _string2.default(list.car.value.normalize('NFC'));
}, ['string']), new _nativeProcedure2.default('string-normalize-nfkc', function (list) {
  (0, _assert2.default)(list.car, 'string');
  return new _string2.default(list.car.value.normalize('NFKC'));
}, ['string']), _unicode2.default];