'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createComparator;

var _nativeProcedure = require('../../value/nativeProcedure');

var _nativeProcedure2 = _interopRequireDefault(_nativeProcedure);

var _boolean = require('../../value/boolean');

var _boolean2 = _interopRequireDefault(_boolean);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createComparator(name, type, comp) {
  return new _nativeProcedure2.default(name, function (list) {
    if (!list.car || list.car.type !== type) {
      return new _boolean2.default(false);
    }
    var first = list.car.value;
    return new _boolean2.default(list.cdr.every(function (v) {
      var result = v.type === type && comp(first, v.value);
      first = v.value;
      return result;
    }));
  }, null, 'obj');
}