#!/usr/bin/env node
'use strict';

var _machine = require('./machine');

var _machine2 = _interopRequireDefault(_machine);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _readline = require('readline');

var _readline2 = _interopRequireDefault(_readline);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var machine = new _machine2.default();

if (process.argv[2]) {
  var data = _fs2.default.readFileSync(process.argv[2], 'utf-8');
  try {
    machine.evaluate(data);
  } catch (e) {
    console.log(e.message);
    console.log(machine.getStackTrace(true));
  }
} else {
  (function () {
    var rl = _readline2.default.createInterface({
      input: process.stdin,
      output: process.stdout
    });

    console.log('r6rs REPL');

    var backlog = '';

    var read = function read() {
      var msg = arguments.length <= 0 || arguments[0] === undefined ? 'scm> ' : arguments[0];

      rl.question(msg, function (answer) {
        try {
          console.log(machine.evaluate(backlog + answer));
          backlog = '';
        } catch (e) {
          if (e.message === 'List is not closed') {
            machine.clearStack();
            backlog += answer + '\n';
            read('     ');
            return;
          }
          backlog = '';
          console.log(e.message);
          console.log(machine.getStackTrace(true));
          machine.clearStack();
        }
        read();
      });
    };

    read();
  })();
}