'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = assert;

var _value = require('../value');

var Value = _interopRequireWildcard(_value);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var types = {};

for (var name in Value) {
  if (!/^[A-Z]+$/.test(name)) continue;
  types[name.toLowerCase()] = Value[name];
}

function assert(value, type) {
  var typeObj = void 0;
  if (typeof type === 'string') {
    typeObj = types[type];
  } else {
    typeObj = type;
  }
  if (value == null || value.type !== typeObj) {
    throw new Error('Assertion failed: ' + type + ' expected, ' + value.inspect() + ' received');
  }
}