'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = toObject;
exports.fromAssoc = fromAssoc;

var _type = require('../value/type');

function toObject(obj) {
  if (obj.type === _type.BOOLEAN) return obj.value;
  if (obj.type === _type.NUMBER) return obj.value;
  if (obj.type === _type.CHARACTER) return obj.value;
  if (obj.type === _type.STRING) return obj.value;
  if (obj.type === _type.SYMBOL) return obj.value;
  if (obj.type === _type.PAIR) {
    var arr = obj.toArray();
    arr = arr.map(toObject);
    return arr;
  }
  throw new Error('Unknown object type ' + obj.inspect());
}

// Converts assoc array (JS) to object
// Simple utility function that converts r6rs objects to JavaScript objects
function fromAssoc(obj) {
  var output = {};
  obj.forEach(function (v) {
    output[v[0]] = v[1];
  });
  return output;
}