'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _procedure = require('./procedure');

var _procedure2 = _interopRequireDefault(_procedure);

var _pair = require('./pair');

var _pair2 = _interopRequireDefault(_pair);

var _type = require('./type');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LambdaValue = function (_ProcedureValue) {
  _inherits(LambdaValue, _ProcedureValue);

  function LambdaValue(name, args, code, scope) {
    _classCallCheck(this, LambdaValue);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(LambdaValue).call(this, 'procedure', name, args, code, scope));
  }

  _createClass(LambdaValue, [{
    key: 'execute',
    value: function execute(machine, frame) {
      if (frame.procTrack == null) {
        // Create scope and put variables into it, if it isn't specified.
        if (frame.scopeTrack == null) {
          var procedure = frame.procedure;
          var expression = frame.expression;
          // Create stack's own scope. Note that parent scope is not parent
          // stack; parent scope is marked in the procedure.

          frame.scopeTrack = new _pair2.default({}, procedure.scope);
          frame.expTrack = expression.cdr;
          frame.argsTrack = procedure.args;
          if (frame.argsTrack.type !== _type.PAIR) {
            frame.argsList = true;
          }
          frame.result = null;
        }
        if (frame.result != null) {
          // If the result is present, put the data to the scope.
          var scope = frame.scopeTrack.car;
          if (frame.argsList) {
            var pairArgs = new _pair2.default(frame.result, null);
            if (frame.argsTrack.type !== _type.PAIR) {
              if (frame.argsTrack.type !== _type.SYMBOL) {
                throw new Error('Symbol expected, ' + frame.argsTrack.inspect() + ' received');
              }
              scope[frame.argsTrack.value] = pairArgs;
            } else {
              frame.argsTrack.cdr = pairArgs;
            }
            frame.argsTrack = pairArgs;
          } else {
            if (frame.argsTrack.car.type !== _type.SYMBOL) {
              throw new Error('Symbol expected, ' + frame.argsTrack.inspect() + ' received');
            }
            // Normal value; just put it.
            scope[frame.argsTrack.car.value] = frame.result;
            // Advance to next step...
            if (frame.argsTrack.cdr && frame.argsTrack.cdr.type !== _type.PAIR) {
              // Start list hell...
              frame.argsList = true;
            }
            frame.argsTrack = frame.argsTrack.cdr;
          }
          frame.expTrack = frame.expTrack.cdr;
        }
        if (frame.argsTrack != null && (frame.argsTrack.type != _type.PAIR || frame.argsTrack.car != null)) {
          if (frame.expTrack) {
            // Try to resolve the expression value.
            if (frame.noResolve) {
              frame.result = frame.expTrack.car || new _pair2.default();
              return;
            }
            machine.pushStack(frame.expTrack.car);
            return;
          } else if (!frame.argsList) {
            // Data underflow.
            throw new Error('Argument ' + frame.argsTrack.car.inspect() + ' is missing');
          } else if (frame.argsTrack.type !== _type.PAIR) {
            // if argsTrack is not pair, try to add empty list to it
            if (frame.argsTrack.type !== _type.SYMBOL) {
              throw new Error('Symbol expected, ' + frame.argsTrack.inspect() + ' received');
            }
            frame.scopeTrack.car[frame.argsTrack.value] = new _pair2.default();
          }
        }
        // Finalize scope and start processing.
        frame.scope = frame.scopeTrack;
        frame.procTrack = frame.procedure.code;
      }
      // Start executing the code! :P
      var code = void 0;
      if (frame.procTrack.type === _type.PAIR) {
        code = frame.procTrack.car;
        frame.procTrack = frame.procTrack.cdr;
      } else {
        code = frame.procTrack;
        frame.procTrack = null;
      }
      if (code.type === _type.PAIR) {
        if (frame.procTrack == null) {
          // TCO!
          machine.jumpStack(code);
          return true;
        } else {
          machine.pushStack(code);
        }
      } else if (code.type === _type.SYMBOL) {
        if (frame.procTrack == null) {
          frame.result = machine.getVariable(code.value);
          return true;
        }
      } else {
        if (frame.procTrack == null) {
          frame.result = code;
          return true;
        }
      }
    }
  }]);

  return LambdaValue;
}(_procedure2.default);

exports.default = LambdaValue;