'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _procedure = require('./procedure');

var _procedure2 = _interopRequireDefault(_procedure);

var _pair = require('./pair');

var _pair2 = _interopRequireDefault(_pair);

var _type = require('./type');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NativeProcedureValue = function (_ProcedureValue) {
  _inherits(NativeProcedureValue, _ProcedureValue);

  function NativeProcedureValue(name, code, args, argsExtra) {
    _classCallCheck(this, NativeProcedureValue);

    var argsPair = null;
    if (args) argsPair = _pair2.default.fromArray(args);
    if (argsExtra != null) {
      if (argsPair == null) {
        argsPair = argsExtra;
      } else {
        var node = argsPair;
        while (node != null && node.cdr != null && node.cdr.type === _type.PAIR) {
          node = node.cdr;
        }
        node.cdr = argsExtra;
      }
    }
    return _possibleConstructorReturn(this, Object.getPrototypeOf(NativeProcedureValue).call(this, 'procedure<native>', name, code, argsPair));
  }

  _createClass(NativeProcedureValue, [{
    key: 'execute',
    value: function execute(machine, frame) {
      if (frame.procTrack == null) {
        // Put everything to the list... And no, we don't need scope
        if (frame.list == null) {
          var expression = frame.expression;

          frame.expTrack = expression.cdr;
          frame.listTrack = false;
          frame.list = false;
          frame.result = null;
        }
        if (frame.result != null) {
          var pair = new _pair2.default(frame.result, null);
          if (!frame.list) {
            frame.list = pair;
            frame.listTrack = pair;
          } else {
            frame.listTrack.cdr = pair;
            frame.listTrack = pair;
          }
          frame.expTrack = frame.expTrack.cdr;
        }
        if (frame.expTrack != null) {
          // Try to resolve the expression value.
          if (frame.noResolve) {
            frame.result = frame.expTrack.car || new _pair2.default();
            return;
          }
          machine.pushStack(frame.expTrack.car);
          return;
        } else {
          // Start processing.
          frame.procTrack = 0;
        }
      }
      // Start executing the code! :P
      var result = frame.procedure.code(frame.list, machine, frame);
      if (result !== undefined) {
        frame.result = result;
        return true;
      }
      frame.procTrack += 1;
      return result;
    }
  }]);

  return NativeProcedureValue;
}(_procedure2.default);

exports.default = NativeProcedureValue;