'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _procedure = require('./procedure');

var _procedure2 = _interopRequireDefault(_procedure);

var _pair = require('./pair');

var _pair2 = _interopRequireDefault(_pair);

var _type = require('./type');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NativeSyntaxValue = function (_ProcedureValue) {
  _inherits(NativeSyntaxValue, _ProcedureValue);

  function NativeSyntaxValue(name, code, args, argsExtra) {
    _classCallCheck(this, NativeSyntaxValue);

    var argsPair = null;
    if (args) argsPair = _pair2.default.fromArray(args);
    if (argsExtra != null) {
      if (argsPair == null) {
        argsPair = argsExtra;
      } else {
        var node = argsPair;
        while (node != null && node.cdr != null && node.cdr.type === _type.PAIR) {
          node = node.cdr;
        }
        node.cdr = argsExtra;
      }
    }
    return _possibleConstructorReturn(this, Object.getPrototypeOf(NativeSyntaxValue).call(this, 'syntax', name, code, argsPair));
  }

  _createClass(NativeSyntaxValue, [{
    key: 'execute',
    value: function execute(machine, frame) {
      // Completely skip the arguments checking code.
      if (frame.procTrack == null) {
        frame.procTrack = 0;
        frame.expTrack = frame.expression.cdr;
      }
      // Start executing the code! :P
      var result = frame.procedure.code(machine, frame);
      frame.procTrack += 1;
      return result;
    }
  }]);

  return NativeSyntaxValue;
}(_procedure2.default);

exports.default = NativeSyntaxValue;