'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _type = require('./type');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PairValue = function () {
  function PairValue(car, cdr) {
    _classCallCheck(this, PairValue);

    this.type = _type.PAIR;
    this.car = car;
    this.cdr = cdr;
  }

  _createClass(PairValue, [{
    key: 'isEmpty',
    value: function isEmpty() {
      return this.car == null && this.cdr == null;
    }
  }, {
    key: 'isList',
    value: function isList() {
      var node = this;
      while (node != null && node.type === _type.PAIR) {
        node = node.cdr;
      }
      return node === null;
    }
  }, {
    key: 'length',
    value: function length() {
      var cdr = arguments.length <= 0 || arguments[0] === undefined ? true : arguments[0];

      var n = 0;
      var node = this;
      while (node != null && node.type === _type.PAIR) {
        if (node.car != null) n++;
        node = node.cdr;
      }
      if (node != null && cdr) n++;
      return n;
    }
  }, {
    key: 'forEach',
    value: function forEach(callback, thisArg) {
      var n = 0;
      var node = this;
      while (node != null && node.type === _type.PAIR) {
        if (node.car != null) {
          callback.call(thisArg, node.car, n, this);
        }
        n++;
        node = node.cdr;
      }
      if (node != null) {
        callback.call(thisArg, node, n, this);
      }
    }
  }, {
    key: 'every',
    value: function every(callback, thisArg) {
      var n = 0;
      var node = this;
      while (node != null && node.type === _type.PAIR) {
        if (node.car != null) {
          if (!callback.call(thisArg, node.car, n, this)) return false;
        }
        n++;
        node = node.cdr;
      }
      if (node != null) {
        if (!callback.call(thisArg, node, n, this)) return false;
      }
      return true;
    }
  }, {
    key: 'some',
    value: function some(callback, thisArg) {
      var n = 0;
      var node = this;
      while (node != null && node.type === _type.PAIR) {
        if (node.car != null) {
          if (callback.call(thisArg, node.car, n, this)) return true;
        }
        n++;
        node = node.cdr;
      }
      if (node != null) {
        if (callback.call(thisArg, node, n, this)) return true;
      }
      return false;
    }
  }, {
    key: 'filter',
    value: function filter(callback, thisArg) {
      var parent = void 0,
          rootNode = void 0;
      var node = this;
      var n = 0;
      while (node != null && node.type === _type.PAIR) {
        if (node.car != null && callback.call(thisArg, node.car, n, this)) {
          var o = new PairValue(node.car, null);
          if (parent) {
            parent.cdr = o;
            parent = o;
          } else {
            parent = o;
            rootNode = o;
          }
        }
        n++;
        node = node.cdr;
      }
      if (node != null) {
        if (callback.call(thisArg, node, n, this)) {
          if (parent) parent.cdr = node;
        }
      }
      return rootNode || new PairValue();
    }
  }, {
    key: 'map',
    value: function map(callback, thisArg) {
      var parent = void 0,
          rootNode = void 0;
      var node = this;
      var n = 0;
      while (node != null && node.type === _type.PAIR) {
        var o = void 0;
        if (node.car == null) {
          o = new PairValue();
        } else {
          o = new PairValue(callback.call(thisArg, node.car, n, this), null);
        }
        if (parent) {
          parent.cdr = o;
          parent = o;
        } else {
          parent = o;
          rootNode = o;
        }
        n++;
        node = node.cdr;
      }
      if (node != null) {
        if (parent) parent.cdr = callback.call(thisArg, node, n, this);
      }
      return rootNode;
    }
  }, {
    key: 'concat',
    value: function concat(target) {
      var parent = void 0,
          rootNode = void 0;
      var node = this;
      while (node != null && node.type === _type.PAIR) {
        var o = new PairValue(node.car, null);
        if (parent) {
          parent.cdr = o;
          parent = o;
        } else {
          parent = o;
          rootNode = o;
        }
        node = node.cdr;
      }
      if (node != null) {
        var _o = new PairValue(node, null);
        if (parent) {
          parent.cdr = _o;
          parent = _o;
        } else {
          parent = _o;
          rootNode = _o;
        }
      }
      node = target;
      while (node != null && node.type === _type.PAIR) {
        var _o2 = new PairValue(node.car, null);
        if (parent) {
          parent.cdr = _o2;
          parent = _o2;
        } else {
          parent = _o2;
          rootNode = _o2;
        }
        node = node.cdr;
      }
      if (node != null) {
        if (parent) parent.cdr = node;
      }
      return rootNode;
    }
    // Create deep copy of the list.

  }, {
    key: 'copy',
    value: function copy() {
      var parent = void 0,
          rootNode = void 0;
      var node = this;
      var n = 0;
      while (node != null && node.type === _type.PAIR) {
        if (node.car) {
          var o = new PairValue(node.car, null);
          if (parent) {
            parent.cdr = o;
            parent = o;
          } else {
            parent = o;
            rootNode = o;
          }
        }
        n++;
        node = node.cdr;
      }
      if (node != null) {
        if (parent) parent.cdr = node;
      }
      return rootNode || new PairValue();
    }
  }, {
    key: 'reduce',
    value: function reduce(callback, initialValue) {
      var node = this;
      var currentValue = initialValue,
          currentIndex = 0;
      if (initialValue === undefined) {
        node = this.cdr;
        currentValue = this.car;
        currentIndex = 1;
        if (this.car == null) {
          throw new TypeError('Reduce of empty list with no initial value');
        }
      }
      while (node != null && node.type === _type.PAIR) {
        if (node.car != null) {
          currentValue = callback(currentValue, node.car, currentIndex, this);
          currentIndex++;
        }
        node = node.cdr;
      }
      if (node != null) {
        currentValue = callback(currentValue, node, currentIndex, this);
      }
      return currentValue;
    }
  }, {
    key: 'toArray',
    value: function toArray() {
      var output = [];
      var node = this;
      while (node != null && node.type === _type.PAIR) {
        if (node.car != null) output.push(node.car);
        node = node.cdr;
      }
      if (node != null) {
        output.push(node);
      }
      return output;
    }
  }, {
    key: 'inspect',
    value: function inspect() {
      var output = [];
      var node = this;
      while (node != null && node.type === _type.PAIR) {
        if (node.car != null) {
          output.push(node.car.inspect ? node.car.inspect() : node.car);
        }
        node = node.cdr;
      }
      if (node != null) {
        output.push('.');
        output.push(node.inspect ? node.inspect() : node);
      }
      return '(' + output.join(' ') + ')';
    }
  }], [{
    key: 'fromArray',
    value: function fromArray(array) {
      var parent = null;
      var rootNode = null;
      for (var i = 0; i < array.length; ++i) {
        var o = new PairValue(array[i], null);
        if (parent) {
          parent.cdr = o;
          parent = o;
        } else {
          parent = o;
          rootNode = o;
        }
      }
      return rootNode;
    }
  }]);

  return PairValue;
}();

exports.default = PairValue;