'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _type = require('./type');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ProcedureValue = function () {
  function ProcedureValue(className, name, code, args, scope) {
    _classCallCheck(this, ProcedureValue);

    this.type = _type.PROCEDURE;
    this.className = className;
    this.name = name;
    this.args = args;
    this.code = code;
    this.scope = scope;
  }

  _createClass(ProcedureValue, [{
    key: 'isNative',
    value: function isNative() {
      return typeof this.code === 'function';
    }
  }, {
    key: 'execute',
    value: function execute(machine, stack) {
      // eslint-disable-line no-unused-vars
      throw new Error('ProcedureValue subclass did not implement execute' + ' function.');
    }
  }, {
    key: 'inspect',
    value: function inspect() {
      var argsText = '';
      if (this.args && (this.args.type === _type.PAIR || this.args.type === _type.SYMBOL)) {
        // User-defined functions have LISP list as args list
        argsText = this.args.inspect();
      } else if (this.args != null) {
        argsText = this.args;
      }
      return '#<' + this.className + ' ' + this.name + ' ' + argsText + '>';
    }
  }]);

  return ProcedureValue;
}();

exports.default = ProcedureValue;