"use strict";

;module.exports = "\n(define-syntax let\n  (syntax-rules ()\n    ((let ((name val) ...) body1 body2 ...)\n     ((lambda (name ...) body1 body2 ...)\n       val ...))\n    ((let tag ((name val) ...) body1 body2 ...)\n     ((letrec ((tag (lambda (name ...) body1 body2 ...))) tag)\n       val ...))))\n\n(define-syntax let*\n  (syntax-rules ()\n    ((let* () body1 body2 ...)\n     (let () body1 body2 ...))\n    ((let* ((name1 expr1) (name2 expr2) ...) body1 body2 ...)\n     (let ((name1 expr1))\n       (let* ((name2 expr2) ...) body1 body2 ...)))))\n\n; letrec, letrec*, let-values, let*-values\n\n(define-syntax and\n  (syntax-rules ()\n    ((and) #t)\n    ((and test) test)\n    ((and test1 test2 ...)\n     (if test1 (and test2 ...) #f))))\n\n(define-syntax or\n  (syntax-rules ()\n    ((or) #f)\n    ((or test) test)\n    ((or test1 test2 ...)\n     (let ((x test1))\n       (if x x (or test2 ...))))))\n\n(define-syntax define\n  (syntax-rules ()\n    ((define var) (define var '()))\n    ((define (var formals ...) body1 body2 ...)\n      (define var (lambda (formals ...) body1 body2 ...)))\n    ((define (var . formal) body1 body2 ...)\n      (define var (lambda formal body1 body2 ...)))\n  )\n)\n\n(define (eq? a b) (eqv? a b))\n\n; ";