"use strict";

;module.exports = "\n\n(define-syntax cond\n  (syntax-rules (else =>)\n    ((cond (else result1 result2 ...))\n     (begin result1 result2 ...))\n    ((cond (test => result))\n     (let ((temp test))\n       (if temp (result temp))))\n    ((cond (test => result) clause1 clause2 ...)\n     (let ((temp test))\n       (if temp\n           (result temp)\n           (cond clause1 clause2 ...))))\n    ((cond (test)) test)\n    ((cond (test) clause1 clause2 ...)\n     (let ((temp test))\n       (if temp\n           temp\n           (cond clause1 clause2 ...))))\n    ((cond (test result1 result2 ...))\n     (if test (begin result1 result2 ...)))\n    ((cond (test result1 result2 ...)\n           clause1 clause2 ...)\n     (if test\n         (begin result1 result2 ...)\n         (cond clause1 clause2 ...)))))\n\n(define-syntax let\n  (syntax-rules ()\n    ((let ((name val) ...) body1 body2 ...)\n     ((lambda (name ...) body1 body2 ...)\n       val ...))\n    ((let tag ((name val) ...) body1 body2 ...)\n     ((letrec ((tag (lambda (name ...) body1 body2 ...))) tag)\n       val ...))))\n\n(define-syntax let*\n  (syntax-rules ()\n    ((let* () body1 body2 ...)\n     (let () body1 body2 ...))\n    ((let* ((name1 expr1) (name2 expr2) ...) body1 body2 ...)\n     (let ((name1 expr1))\n       (let* ((name2 expr2) ...) body1 body2 ...)))))\n\n; letrec, letrec*, let-values, let*-values\n\n(define-syntax letrec\n  (syntax-rules ()\n    ((letrec () body1 body2 ...)\n     (let () body1 body2 ...))\n    ((letrec ((var init) ...) body1 body2 ...)\n     (letrec-helper\n       (var ...)\n       ()\n       ((var init) ...)\n       body1 body2 ...))))\n\n(define-syntax letrec-helper\n  (syntax-rules ()\n    ((letrec-helper\n       ()\n       (temp ...)\n       ((var init) ...)\n       body1 body2 ...)\n     (let ((var '()) ...)\n       (let ((temp init) ...)\n         (set! var temp)\n         ...)\n       (let () body1 body2 ...)))\n    ((letrec-helper\n       (x y ...)\n       (temp ...)\n       ((var init) ...)\n       body1 body2 ...)\n     (letrec-helper\n       (y ...)\n       (newtemp temp ...)\n       ((var init) ...)\n       body1 body2 ...))))\n\n(define-syntax letrec*\n  (syntax-rules ()\n    ((letrec* ((var1 init1) ...) body1 body2 ...)\n      (let ((var1 <undefined>) ...)\n        (set! var1 init1)\n        ...\n        (let () body1 body2 ...)))))\n\n(define-syntax let-values\n  (syntax-rules ()\n    ((let-values (binding ...) body1 body2 ...)\n     (let-values-helper1\n       ()\n       (binding ...)\n       body1 body2 ...))))\n\n(define-syntax let-values-helper1\n  ;; map over the bindings\n  (syntax-rules ()\n    ((let-values\n       ((id temp) ...)\n       ()\n       body1 body2 ...)\n     (let ((id temp) ...) body1 body2 ...))\n    ((let-values\n       assocs\n       ((formals1 expr1) (formals2 expr2) ...)\n       body1 body2 ...)\n     (let-values-helper2\n       formals1\n       ()\n       expr1\n       assocs\n       ((formals2 expr2) ...)\n       body1 body2 ...))))\n\n(define-syntax let-values-helper2\n  ;; create temporaries for the formals\n  (syntax-rules ()\n    ((let-values-helper2\n       ()\n       temp-formals\n       expr1\n       assocs\n       bindings\n       body1 body2 ...)\n     (call-with-values\n       (lambda () expr1)\n       (lambda temp-formals\n         (let-values-helper1\n           assocs\n           bindings\n           body1 body2 ...))))\n    ((let-values-helper2\n       (first . rest)\n       (temp ...)\n       expr1\n       (assoc ...)\n       bindings\n       body1 body2 ...)\n     (let-values-helper2\n       rest\n       (temp ... newtemp)\n       expr1\n       (assoc ... (first newtemp))\n       bindings\n       body1 body2 ...))\n    ((let-values-helper2\n       rest-formal\n       (temp ...)\n       expr1\n       (assoc ...)\n       bindings\n       body1 body2 ...)\n     (call-with-values\n       (lambda () expr1)\n       (lambda (temp ... . newtemp)\n         (let-values-helper1\n           (assoc ... (rest-formal newtemp))\n           bindings\n           body1 body2 ...))))))\n\n(define-syntax let*-values\n  (syntax-rules ()\n    ((let*-values () body1 body2 ...)\n     (let () body1 body2 ...))\n    ((let*-values (binding1 binding2 ...)\n       body1 body2 ...)\n     (let-values (binding1)\n       (let*-values (binding2 ...)\n         body1 body2 ...)))))\n\n(define-syntax and\n  (syntax-rules ()\n    ((and) #t)\n    ((and test) test)\n    ((and test1 test2 ...)\n     (if test1 (and test2 ...) #f))))\n\n(define-syntax or\n  (syntax-rules ()\n    ((or) #f)\n    ((or test) test)\n    ((or test1 test2 ...)\n     (let ((x test1))\n       (if x x (or test2 ...))))))\n\n(define-syntax define\n  (syntax-rules ()\n    ((define var) (define var '()))\n    ((define (var formals ... . formalEnd) body1 body2 ...)\n      (define var (lambda (formals ... . formalEnd) body1 body2 ...)))\n    ((define (var formals ...) body1 body2 ...)\n      (define var (lambda (formals ...) body1 body2 ...)))\n    ((define (var . formal) body1 body2 ...)\n      (define var (lambda formal body1 body2 ...)))\n  )\n)\n\n(define (eq? a b) (eqv? a b))\n\n; ";